require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe ActorFanlistsController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # ActorFanlist. As you add validations to ActorFanlist, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    skip("Add a hash of attributes valid for your model")
  }

  let(:invalid_attributes) {
    skip("Add a hash of attributes invalid for your model")
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # ActorFanlistsController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  describe "GET #index" do
    it "assigns all actor_fanlists as @actor_fanlists" do
      actor_fanlist = ActorFanlist.create! valid_attributes
      get :index, params: {}, session: valid_session
      expect(assigns(:actor_fanlists)).to eq([actor_fanlist])
    end
  end

  describe "GET #show" do
    it "assigns the requested actor_fanlist as @actor_fanlist" do
      actor_fanlist = ActorFanlist.create! valid_attributes
      get :show, params: {id: actor_fanlist.to_param}, session: valid_session
      expect(assigns(:actor_fanlist)).to eq(actor_fanlist)
    end
  end

  describe "GET #new" do
    it "assigns a new actor_fanlist as @actor_fanlist" do
      get :new, params: {}, session: valid_session
      expect(assigns(:actor_fanlist)).to be_a_new(ActorFanlist)
    end
  end

  describe "GET #edit" do
    it "assigns the requested actor_fanlist as @actor_fanlist" do
      actor_fanlist = ActorFanlist.create! valid_attributes
      get :edit, params: {id: actor_fanlist.to_param}, session: valid_session
      expect(assigns(:actor_fanlist)).to eq(actor_fanlist)
    end
  end

  describe "POST #create" do
    context "with valid params" do
      it "creates a new ActorFanlist" do
        expect {
          post :create, params: {actor_fanlist: valid_attributes}, session: valid_session
        }.to change(ActorFanlist, :count).by(1)
      end

      it "assigns a newly created actor_fanlist as @actor_fanlist" do
        post :create, params: {actor_fanlist: valid_attributes}, session: valid_session
        expect(assigns(:actor_fanlist)).to be_a(ActorFanlist)
        expect(assigns(:actor_fanlist)).to be_persisted
      end

      it "redirects to the created actor_fanlist" do
        post :create, params: {actor_fanlist: valid_attributes}, session: valid_session
        expect(response).to redirect_to(ActorFanlist.last)
      end
    end

    context "with invalid params" do
      it "assigns a newly created but unsaved actor_fanlist as @actor_fanlist" do
        post :create, params: {actor_fanlist: invalid_attributes}, session: valid_session
        expect(assigns(:actor_fanlist)).to be_a_new(ActorFanlist)
      end

      it "re-renders the 'new' template" do
        post :create, params: {actor_fanlist: invalid_attributes}, session: valid_session
        expect(response).to render_template("new")
      end
    end
  end

  describe "PUT #update" do
    context "with valid params" do
      let(:new_attributes) {
        skip("Add a hash of attributes valid for your model")
      }

      it "updates the requested actor_fanlist" do
        actor_fanlist = ActorFanlist.create! valid_attributes
        put :update, params: {id: actor_fanlist.to_param, actor_fanlist: new_attributes}, session: valid_session
        actor_fanlist.reload
        skip("Add assertions for updated state")
      end

      it "assigns the requested actor_fanlist as @actor_fanlist" do
        actor_fanlist = ActorFanlist.create! valid_attributes
        put :update, params: {id: actor_fanlist.to_param, actor_fanlist: valid_attributes}, session: valid_session
        expect(assigns(:actor_fanlist)).to eq(actor_fanlist)
      end

      it "redirects to the actor_fanlist" do
        actor_fanlist = ActorFanlist.create! valid_attributes
        put :update, params: {id: actor_fanlist.to_param, actor_fanlist: valid_attributes}, session: valid_session
        expect(response).to redirect_to(actor_fanlist)
      end
    end

    context "with invalid params" do
      it "assigns the actor_fanlist as @actor_fanlist" do
        actor_fanlist = ActorFanlist.create! valid_attributes
        put :update, params: {id: actor_fanlist.to_param, actor_fanlist: invalid_attributes}, session: valid_session
        expect(assigns(:actor_fanlist)).to eq(actor_fanlist)
      end

      it "re-renders the 'edit' template" do
        actor_fanlist = ActorFanlist.create! valid_attributes
        put :update, params: {id: actor_fanlist.to_param, actor_fanlist: invalid_attributes}, session: valid_session
        expect(response).to render_template("edit")
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested actor_fanlist" do
      actor_fanlist = ActorFanlist.create! valid_attributes
      expect {
        delete :destroy, params: {id: actor_fanlist.to_param}, session: valid_session
      }.to change(ActorFanlist, :count).by(-1)
    end

    it "redirects to the actor_fanlists list" do
      actor_fanlist = ActorFanlist.create! valid_attributes
      delete :destroy, params: {id: actor_fanlist.to_param}, session: valid_session
      expect(response).to redirect_to(actor_fanlists_url)
    end
  end

end
